PGOBLIN_BANG(-f)
 -- Copyright (C)2019..2022 @BABOLO http://www.babolo.ru/
 -- package = PKG
 -- All rights reserved.
 --
 -- Redistribution and use in source and binary forms, with or without
 -- modification, are permitted provided that the following conditions
 -- are met:
 -- 1. Redistributions of source code must retain the above copyright
 --    notice, this list of conditions and the following disclaimer.
 -- 2. Redistributions in binary form must reproduce the above copyright
 --    notice, this list of conditions and the following disclaimer in the
 --    documentation and/or other materials provided with the distribution.
 --
 -- THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 -- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 -- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 -- ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 -- FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 -- DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 -- OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 -- HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 -- LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 -- OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 -- SUCH DAMAGE.
 --
 -- $Id: copyall.pgoblin.m4,v 1.3 2022/02/20 20:52:26 babolo Exp $

#echo    Q
##Q copy E
#style   00Q00Q
Q
#cat     N
/dev/null
#connect 0001
sqlite2 :memory:
#perform 0001
CREATE TEMP TABLE a(i int, a text);
#getarg  1
#copyin  0011
COPY a;
#select  d001
SELECT a FROM a WHERE i = 0 LIMIT 1;
#select  10d1
SELECT '/bin/mkdir', '-p', ?
#exec    01N
#wait
#select  b001
SELECT 'pgsql'
    || COALESCE(' dbname=' || (SELECT a FROM a WHERE i = 1 LIMIT 1), '')
    || ' requirepeer=postgres application_name=CIPA_PKG_copyall'
#connect 0b02
#select  o0d2
WITH a AS(SELECT quote_ident(n.nspname) AS nsp
               , quote_ident(c.relname) AS rel
               , pg_table_size(c.oid)   AS sz
           FROM pg_catalog.pg_class c JOIN pg_catalog.pg_namespace n ON(n.oid = c.relnamespace)
           WHERE c.relkind = 'r'
             AND n.nspname !~ '^pg_'
             AND n.nspname <> 'information_schema'
             AND c.relname !~ '^pg_'
         )
SELECT '
##file    D
' || $1 || '/' || nsp || '.' || rel || '
##copyout D002
COPY ' || nsp || '.' || rel || ' TO stdout;
##close   D0D'
 FROM a
ORDER BY sz
;
#display 00o00Q
#eval    0o
